<?php
namespace WPUmbrella\Controller;

use WPUmbrella\Core\Models\AbstractController;

if (!defined('ABSPATH')) {
    exit;
}

class Login extends AbstractController
{
    public function executeGet($params)
    {

		if (!isset($params['user_id']) || !isset($params['_nonce']) || !isset($params['x-umbrella'])) {
            return $this->returnResponse([
                'code' => 'missing_parameters'
            ], 401);
        }

        $token = $params['x-umbrella'];
        $projectId = $params['x-project'];
        $response = wp_umbrella_get_service('ApiWordPressPermission')->isAuthorizedToken($token);

        if (!isset($response['authorized']) || !$response['authorized']) {
            return $this->returnResponse(['code' => $response['code'], 'message' => $response['message']],401);
        }

        $response = wp_umbrella_get_service('ApiWordPressPermission')->isAuthorizedProjectId($projectId);
        if (!isset($response['authorized']) || !$response['authorized']) {
            return $this->returnResponse(['code' => $response['code'], 'message' => $response['message']],401);
        }

        $transient = get_option('wp_umbrella_login');
        delete_option('wp_umbrella_login');

        if (!$transient || $params['_nonce'] !== $transient) {
            return $this->returnResponse([
                'code' => 'not_authorized_nonce'
            ], 401);
        }

        $user = wp_umbrella_get_service('WordPressContext')->getUserData($params['user_id']);
        if (!$user) {
            return $this->returnResponse([
                'code' => 'user_not_exist'
            ], 401);
        }

        wp_set_current_user($user->ID, $user->user_login);
        wp_set_auth_cookie($user->ID);

        wp_redirect(admin_url('index.php'));
        exit;
    }
}
