<?php
namespace WPUmbrella\Controller;

use WPUmbrella\Core\Models\AbstractController;

if (!defined('ABSPATH')) {
    exit;
}

class Snapshot extends AbstractController
{
    public function executeGet($params)
    {
		if (function_exists('wp_clean_update_cache') && apply_filters('wp_umbrella_clean_cache_on_request', false)) {
            wp_clean_update_cache();
        }

        if(function_exists('wp_update_plugins')){
			wp_update_plugins();
		}

        if(function_exists('wp_update_themes')){
			wp_update_themes();
		}

        if(function_exists('wp_version_check')){
			wp_version_check();
			wp_version_check(array(), true);
		}

        $plugins = wp_umbrella_get_service('PluginsProvider')->getPlugins();
        $wordpressData = wp_umbrella_get_service('WordPressProvider')->get();
        $themes = wp_umbrella_get_service('ThemesProvider')->getThemes();

        return $this->returnResponse([
            'plugins' => $plugins,
            'warnings' => $wordpressData,
            'themes' => $themes
        ]);
    }
}
