<?php
namespace WPUmbrella\Services\Backup\V2;

class BackupStandalone
{
	public function writeKernel(){
		try {


			$file = 'umbrella-backup.php';
			$current = sprintf("<?php
			require_once  '%s/index.php';
			",WP_UMBRELLA_DIR_WPU_BACKUP);

			file_put_contents(sprintf('%s/%s', ABSPATH, $file), $current);


			$value = [
				'api_url' => WP_UMBRELLA_API_URL,
				'site_url' => site_url(),
				'version' => WP_UMBRELLA_VERSION,
				'is_multisite' => is_multisite() ? 'true' : 'false',
				'abspath' => ABSPATH,
				'wpinc' => WPINC,
				'wp_content_dir' => WP_CONTENT_DIR,
				'dbname' => DB_NAME,
				'user' => DB_USER,
				'password' => DB_PASSWORD,
				'charset' => DB_CHARSET,
				'host' => DB_HOST,
				'collate' => DB_COLLATE,
			];

			$apiKey = wp_umbrella_get_api_key();
			$projectId = wp_umbrella_get_project_id();

			$file = 'security.php';
			$current = "<?php

if(!defined('WP_UMBRELLA_INIT_BACKUP')){
	die('Oups');
}

define('TOKEN', '{$apiKey}');
define('PROJECT_ID', {$projectId});

if(!defined('ABSPATH')){
	define('ABSPATH', '{$value['abspath']}');
}

if(!defined('WPINC')){
	define('WPINC', '{$value['wpinc']}');
}

if(!defined('WP_CONTENT_DIR')){
	define('WP_CONTENT_DIR', '{$value['wp_content_dir']}');
}

if(!defined('WP_UMBRELLA_API_URL')){
	define('WP_UMBRELLA_API_URL', '{$value['api_url']}');
}
if(!defined('SITE_URL')){
	define('SITE_URL', '{$value['site_url']}');
}

if(!defined('WP_UMBRELLA_VERSION')){
	define('WP_UMBRELLA_VERSION', '{$value['version']}');
}

if(!defined('IS_MULTISITE')){
	define('IS_MULTISITE', {$value['is_multisite']});
}

if(!defined('DB_NAME')){
	define('DB_NAME', '{$value['dbname']}');
}

if(!defined('DB_USER')){
	define('DB_USER', '{$value['user']}');
}

if(!defined('DB_PASSWORD')){
	define('DB_PASSWORD', '{$value['password']}');
}

if(!defined('DB_CHARSET')){
	define('DB_CHARSET', '{$value['charset']}');
}

if(!defined('DB_HOST')){
	define('DB_HOST', '{$value['host']}');
}

if(!defined('DB_COLLATE')){
	define('DB_COLLATE', '{$value['collate']}');
}
			";

			file_put_contents(sprintf('%s/%s', WP_UMBRELLA_DIR_WPU_BACKUP, $file), $current);


			return  [
				'success' => true,
			];
		} catch (\Exception $e) {
			return [
				'success' => false,
				'error_code' => 'write_backup_process_data',
			];
		}
	}

	public function deleteKernel(){
		if(file_exists(sprintf('%s/umbrella-backup.php',ABSPATH))){
			unlink(sprintf('%s/umbrella-backup.php',ABSPATH));
		}

		if(file_exists(sprintf('%s/security.php',WP_UMBRELLA_DIR_WPU_BACKUP))){
			unlink(sprintf('%s/security.php',WP_UMBRELLA_DIR_WPU_BACKUP));
		}

		if(file_exists(sprintf('%s/config.php',WP_UMBRELLA_DIR_WPU_BACKUP))){
			unlink(sprintf('%s/config.php',WP_UMBRELLA_DIR_WPU_BACKUP));
		}
	}

}
